function [out_] = GetMPO(mat2_, op2_, opT_, mat4_, op4_)
  vac = getvac(op2_, [1]);
  opI = permute(QCREATE(op2_, '1', vac, '1*', 'OUT'), [1,3,2]);
  opI_T = permute(opI, [3,2,1], 'conj');

  e0 = contract(opI_T, [3], opI, [1]);
  iso = QCREATE(op2_, '3', op2_, '1', 'OUT');
  e2 = contract(iso, [3], conj(iso), [3], [1,2,4,3]);
  o2 = contract(opI_T, [3], op2_, [1]); 
  oT = contract(opT_, [3], opI, [1]);

  [nrow, ncol] = size(mat2_);
  tmp = cell(nrow,1);
  for irow = 1:nrow
    args = cell(ncol,1);
    for icol = 1:ncol
      obj = QSpace;
      if (irow~=1) && (irow~=nrow) && (icol~=1) && (icol~=ncol)
        obj = mat2_(irow, icol)*e2;
        if ~isempty(op4_) 
           obj = obj + mat4_(irow, icol)*op4_; 
        end

      elseif (icol~=1) && (icol~= ncol)
        obj = mat2_(irow, icol)*o2;

      elseif (irow~=1) && (irow~= nrow)
        obj = mat2_(irow, icol)*oT;
      
      else
        obj = mat2_(irow, icol)*e0;
      end
      args{icol} = obj;
    end

    if (ncol~=1)
      tmp{irow} = QDSUM(args{:}, [4]);
    else
      tmp{irow} = args{1};
    end
  end

  if (nrow~=1)
    out_ = QDSUM(tmp{:}, [1]);
  else
    out_ = tmp{1};
  end
end
