function [outT_] = QCREATE(inpT1_, idx1_, varargin)
  %% construct a unitary tensor outT_
  %% argument format: inpT1_, idx1_, [inpT2_, idx2_, ..., inpTN_, idxN_, flag_]
  %% inpT: QSpace tensor
  %% idx: a string, 'index' or 'index*'
  %% flag_: direction of the last index of outT_  

  lgth = length(varargin);
  %assert((lgth >= 1) && (rem(lgth,2) == 1),'varargin has to have the last tensor index direction')
  
  % first index
  if (idx1_(end) == '*') %out
    kk = str2num(idx1_(1:end-1));
    outT_ = getIdentityQS(inpT1_, [kk], '-0');
    outT_ = conj(QSpace(outT_));
  else
    kk = str2num(idx1_);
    outT_ = getIdentityQS(inpT1_, [kk]);
  end;

  % the rest
  ll = fix(lgth/2);
  for ii = 1:ll
    if (varargin{2*ii}(end) == '*') %out
      kk = str2num(varargin{2*ii}(1:end-1));
      tmp = conj( QSpace(getIdentityQS(varargin{2*ii-1}, [kk], '-0')) );
      tmpI = getIdentityQS(tmp, [2], outT_, [ii+1]);
      tmpI = contract(tmp, [2], QSpace(tmpI), [1]);
      outT_ = contract(outT_, [ii+1], tmpI, [2]);
    else
      kk = str2num(varargin{2*ii});
      tmpI = getIdentityQS(varargin{2*ii-1}, [kk], outT_, [ii+1]);
      outT_ = contract(outT_, [ii+1], QSpace(tmpI), [2]);
    end;
  end;

  % direction of the last index of outT_ 
  switch varargin{end}(1)
  case 'I' 
    outT_ = contract(outT_, [ll+2], QSpace(getIdentity(QSpace(outT_), [ll+2], '-0')), [1]);
  case 'O'
    % do nothing
  otherwise
    error('Error. Ivalid input parameter varargin{end} %s.',varargin{end});
  end
  outT_ = QSpace(outT_);
end
