function [eigE, eigV, info] = QEIG(inpH, nkeep, varargin)
  symQ = []; 
  if (length(varargin)~=0)
   symQ = varargin{1};
  else
    vac = getvac(inpH, [1]);
    symQ = vac.Q{1};
  end 

  nrank = length(inpH.Q);
  [matH, isoU] = QFUSE(inpH, [1:nrank/2], 'IN');
  matH = contract(matH, [2:nrank/2+1], isoU, [1:nrank/2]);
  idx = find(matH.Q{1} == symQ);
  matH = getsub(matH, idx);

  % eigQS
  [eigE, info] = eigQS(matH, 'Nkeep', nkeep);
  eigv = QSpace(info.AK);

  % un-fuse
  eigV = contract(isoU, [nrank/2+1], eigv, [1]);  %Symmetry labels at the last index *** should be zero ***
end
