function [outT_] = QEXP(inpT_, fac_)
  %% inpT_: a rank-4 symmetric tensor a'ab'b
  %% fac_ : a real number
  %% outT_ = exp(fac_*inpT_) a'b'ab

  [mat, isoU] = QFUSE(inpT_, [1,3], 'IN');
  mat = contract(mat, [2,3], isoU, [1,2]);
  
  for ii = 1 : length(mat.data)
    mat.data{ii} = expm(fac_*mat.data{ii});
  end

  mat = contract(isoU, [3], mat, [1]);
  outT_ = contract(mat, [3], conj(QSpace(isoU)), [3]);
end
