function [outT_, fac_] = QRESCALE(inpT_, varargin)
  % rescale so that the maximum tensor element is close to one
  outT_ = inpT_;
  lgth = length(outT_.data);
  max_val = zeros(lgth,1);
  for ii = 1 : lgth
    max_val(ii) = max(abs(outT_.data{ii}(:)));
  end 

  pow2 = floor(log2(max(max_val)));
  if (length(varargin) ~= 0)
    pow2 = pow2 - varargin{1};
  end
  fac_ = 2^(-pow2); % 2^fac ~ 2/maxN_ for the machine accuracy
  outT_ = fac_*outT_;
end
