function [u_, s_, vt_, info_] = QSVD(inpT_, idx_, thresh_, nkeep_, varargin)
  %% SVD patch with svdQS
  %% inpT_: QSpace tensor
  %% idx_: an array of tensor indices collected to u_ 
  %% thresh_: cut-off for singular values
  %% varargin: a character array for new index's itag
  
  %% fuse
  [tmpQ, tmpU] = QFUSE(inpT_, idx_, 'IN', varargin{:});
  rankQ = length(tmpQ.Q);

  %% fuse
  [tmpQ, tmpV] = QFUSE(tmpQ, [2:rankQ], 'OUT', varargin{:});

  [u, s, vt, info_] = svdQS(tmpQ, [2], 'stol', thresh_, 'Nkeep', nkeep_);

  %%un-fuse
  u_ = contract(tmpU, [length(idx_)+1], QSpace(u), [1]);
  s_ = diag(QSpace(s)); 
  vt_ = contract(QSpace(vt), [2], tmpV, [rankQ]);  
end
