function [outT_] = SWAP_GATE(inpT_, idxA_, idxB_)
  global PARAMETERS;

  outT_ = inpT_;
  if (PARAMETERS.FERMION)
    qT = outT_.Q;
    qA = horzcat(qT{idxA_}); 
    qB = horzcat(qT{idxB_});

    switch outT_.info.qtype
    case 'Z2'
      parity = mod(sum(qA,2),2) .* mod(sum(qB,2),2);
    case 'Z2,A'
      parity = mod(sum(qA(:,1:2:end),2),2) .* mod(sum(qB(:,1:2:end),2),2);
    case 'Z2,SU2'
      parity = mod(sum(qA(:,1:2:end),2),2) .* mod(sum(qB(:,1:2:end),2),2);
    case 'SU2,A'
      parity = mod(sum(qA(:,2:2:end),2),2) .* mod(sum(qB(:,2:2:end),2),2);
    otherwise
      error('SWAP_GATE failed. Ivalid qtype %s.', outT_.info.qtype);
    end

    change_sgn = find(parity);
    for ii = 1 : length(change_sgn)
      idata = change_sgn(ii);
      outT_.data{idata} = -outT_.data{idata};
    end
  end
end
